#!/usr/bin/env python
#Classe de configuration

from UserDict import UserDict
from types    import *
import pickle,os

class dataConf(UserDict):
   def __init__(self,dict=None):
      UserDict.__init__(self,dict)

class wabaConf:
   def __init__(self,filename="wabaroK.cfg"):
      self.data=dataConf()
      self.data['configfile']=filename
      #print "config file : "+filename

   def read(self):
      """read from config file"""
      try:
         f=open(self.data['configfile'],"r")
         self.data=pickle.load(f)
         f.close()
      except Exception, detail:
         # cannot read conf file, default values
         print "cannot read file "+str(detail)
         self.data['port']=1234
         self.data['theme']='default'
         self.data['imageWidth']="200"
         self.data['imageHeight']="200"
         self.data['column']=3
   
   def save(self):
      """save config data to file"""
   #~ try:
      f=open(self['configfile'],"w")
      pickle.dump(self.data,f)
      f.close()
      #~ except:
         #~ print "Cannot save config"
   
   def __setitem__(self,key,item): self.data[key]=item
      
   def __getitem__(self,key): return self.data[key]

   def keys(self): return self.data.keys()

   def items(self): return self.data.items()  

   def values(self): return self.data.values()

   def __str__(self): return str(self.data)

   def guiKdialog(self,autoSave=1):
      """GUI to show/update object using kdialog
      autoSave: should the object be saved after gui closed ?"""
      params={'port':        ("Listening port",   "kdialog --inputbox \"%s\" \"%s\" ",IntType),
              'theme':       ("Theme",            "kdialog --inputbox \"%s\" \"%s\" ",StringType),
              'imageWidth':  ("Cover Width",      "kdialog --inputbox \"%s\" \"%s\" ",StringType),
              'imageHeight': ("Cover Height",     "kdialog --inputbox \"%s\" \"%s\" ",StringType),
              'column':      ("Number of Columns","kdialog --inputbox \"%s\" \"%s\" ",IntType)
             }
      ended=0
      while not ended:
         menu = " ".join(["%s '%s (%s)'"%(k,v[0],str(self.data[k])) for k,v in params.items()])
         file=os.popen("""kdialog --menu "Select parameter" %s \
                               --title "wabaroK Configuration" """ % (menu) )
         retour=file.readlines()
         if len(retour)==0:
            ended=1
         else:
            key=retour[0].rstrip('\n')
            #print params[key]
            val=os.popen(params[key][1] % (params[key][0],self.data[key])+" --title 'Change ...'").read().rstrip('\n')
            if val:
               if params[key][2] == IntType:
                  if val.isdigit():
                     self.data[key] = int(val)
                  else:
                     os.system("kdialog --error '%s must be only digits'"%(params[key][0]))
               else:
                  self.data[key]=val
      if autoSave: self.save()

if __name__=='__main__':
   conf = wabaConf()
   conf.read()
   print conf
   #~ conf['imageWidth']="150"
   #~ conf['imageHeight']="150"
   #~ print conf
   #~ conf.save()
   conf.guiKdialog() # with autoSave
   print conf
