#!/usr/bin/env python
# wabaroK : Browse amaroK collection via a web interface

from BaseHTTPServer import HTTPServer
from SimpleHTTPServer import SimpleHTTPRequestHandler
import cgi,os,signal,sys,string
import amaroKdcop
from wabaConf import *
from inputFromAmarok import *

# Handle URLs  :
# / or /index.rok /albums.rok => start page
# /album.rok?id=20 => display album of id 20
# /artists.rok => Show all artists
# /cover?url=path => display album cover of absolut path
# /mp3?url=path => stream mp3 file of absolut path

# configuration object
# Hey a global variable !!
conf = wabaConf(os.path.join(os.getcwd(),"wabaroK.cfg"))


class HTTPHandler (SimpleHTTPRequestHandler):
   server_version = "wabaroK-HTTP/0.1"
   debug=0
   dcop = amaroKdcop.amaroKdcop()
   dico_stats=dcop.getStats()
   dico_artists = dcop.getArtists()
   dico_albums = dcop.getAlbums()
   # 1st char of names placed under # (like numbers) in listColumn
   listSpecChar = ('#','"','[','(','-','_','~','+')

   
   global conf

   def sortbyvalue(self,dict):
      """ Return a list of (key, value) pairs, sorted by value.
      http://www.faqts.com/knowledge_base/view.phtml/aid/4364/fid/541"""
      _swap2 = lambda (x,y): (y,x)
      _cmplower = lambda x, y: cmp(string.lower(x[0]), string.lower(y[0]))
      mdict = map(_swap2, dict.items())
      mdict.sort(_cmplower)
      mdict = map(_swap2, mdict)
      return mdict

   def translate_path(self,path):
      return conf['dataPath']+path

   def do_GET(self):
      if self.path.find('.rok') != -1 or self.path=="/":
         # This is a request that will return html
         if self.path.find('?') != -1:
            self.path, self.requete = self.path.split('?', 1)
         else:
            self.requete = ''
         self.reponseHTML()
      elif self.path[1:6] == "cover":
         # We will display a cover
         self.path, self.requete = self.path.split('?', 1)
         self.cover()
      elif self.path[1:4] == "mp3":
         # We will stream a mp3 file
         self.path, self.requete = self.path.split('?', 1)
         self.mp3()
      else:
         SimpleHTTPRequestHandler.do_GET(self)

   def do_POST(self):
      self.requete = self.rfile.read(int(self.headers['Content-Length']))
      self.reponseHTML()

   def reponseHTML(self):
      self.page = self.path[1:-4]
      self.args = dict(cgi.parse_qsl(self.requete))
      self.send_response(200, 'OK')
      self.send_header('Content-type', 'text/html')
      self.end_headers()
      # send html page
      self.entete()
      self.menu()
      if self.page=="":
         self.page="index"
      if self.page in dir(self) and callable(getattr(self,self.page)):
            getattr(self,self.page)()
      self.piedepage()

   def index(self):
      """Show all albums"""
      self.albums()

   def album(self):
      """Show album content
      id=int"""
      # image = self.dcop.getImage(self.args['id'])
      album = self.dcop.getAlbumContent(self.args['id'])
      if self.debug: print album
      self.wfile.write("<h2>%s - %s</h2>"%(self.dico_albums[album['id']],self.dico_artists[album['artist']]))
      if album['cover'] != "":
         self.wfile.write("""<img src="/cover?url=%s" alt='Album Cover' align='left' width="%s" height="%s" hspace="10">\n"""%(album['cover'],conf['imageWidth'],conf['imageHeight']))
      for l in album['tracks']:
         try:
            (m,s)=divmod(int(l[2]),60)
            self.wfile.write("""%s. <span title="Play song..."><a href="/mp3?url=%s">%s</a></span> (%02d:%02d)<br>\n"""%(l[0].ljust(2),l[3],l[1],m,s))
         except IndexError :
            self.error("No songs in this album")

   def albumsOld(self):
      """Show all albums old version"""
      #albums = self.dcop.getAlbums()
      self.wfile.write("<h2>Albums</h2>")
      list=[]
      header="""<div id="letters"><a href="1">#</a>"""
      letter="# "
      list+="""<h3><a name="1">#</a></h3>"""
      for l in self.sortbyvalue(self.dico_albums):
         if self.debug: print l
         if l[1] != "" and (l[1][0].lower() != letter and not l[1][0].isdigit() and not l[1][0] in self.listSpecChar):
            list+="""<h3><a name="%s">%s</a></h3>"""%(l[1][0].upper(),l[1][0].upper())
            header+="""<a href="#%s">%s</a> """%(l[1][0].upper(),l[1][0].upper())
            letter=l[1][0].lower()
         list+="""<a href="/album.rok?id=%s">%s</a><br>\n"""%(l[0],l[1])
      header+="</div>"
      list.insert(0,header)
      self.listColumn(list)

   def albums(self):
      """Show all albums"""
      self.wfile.write("<h2>Albums</h2>")
      getLetter=lambda l:l[1][0]
      getString=lambda l:"""<a href="/album.rok?id=%s">%s</a><br>\n"""%(l[0],l[1])
      existString=lambda l:l[1]!=""
      list = self.listAlphabetise(self.sortbyvalue(self.dico_albums),existString,getString,getLetter)
      self.listColumn(list,conf['column'])
      if self.debug: print conf
       
   def artistsOld(self):
      """Show all artists"""
      self.wfile.write("<h2>Artists</h2>")
      #artists = self.dcop.getArtists()
      self.wfile.write("<div id='content_left'>")
      c=0
      for k in self.dico_artists.keys():
         if c == int(int(self.dico_stats['artists'])/2): self.wfile.write("</div><div id='content_right'>")
         self.wfile.write("""<a href="/artist.rok?id=%s">%s</a><br>\n"""%(k,self.dico_artists[k]))
         c+=1
      self.wfile.write("</div>")

   def artists(self):
      """Show all artists"""
      self.wfile.write("<h2>Artists</h2>")
      getLetter=lambda l:l[1][0]
      getString=lambda l:"""<a href="/artist.rok?id=%s">%s</a><br>\n"""%(l[0],l[1])
      existString=lambda l:l[1]!=""
      list = self.listAlphabetise(self.sortbyvalue(self.dico_artists),existString,getString,getLetter)
      self.listColumn(list,conf['column'])

   def songs(self):
      """Show all songs"""
      self.wfile.write("<h2>Songs</h2>")
      existString=lambda l:l[0]!=""
      getLetter=lambda l:l[0][0]
      getString=lambda l:"""<span class="bulle_song" title="%s - %s"><a href="/mp3?url=%s">%s</a></span><br>\n"""%(self.dico_artists[l[4]],self.dico_albums[l[3]],l[2],l[0])
      songs = self.dcop.getSongs()
      songs.sort(lambda x, y: cmp(string.lower(x[0]), string.lower(y[0])))
      # ## songs must be sorted !! on songs[2] ## #
      list = self.listAlphabetise(songs,existString,getString,getLetter)
      self.listColumn(list,conf['column'])
      #~ self.wfile.write("<div id='content_left'>")
      #~ c=0
      #~ for l in songs:
         #~ if c == int(int(self.dico_stats['songs'])/2): self.wfile.write("</div><div id='content_right'>")
         #~ self.wfile.write("""<a href="/mp3?url=%s">%s</a><br>\n"""%(l[2],l[0]))
         #~ c+=1
      #~ self.wfile.write("</div>")

   def artist(self):
      """Show albums of an artist
      id=int"""
      self.wfile.write("<h2>Albums of %s</h2>"%(self.dico_artists[self.args['id']]))
      albums = self.dcop.getArtistAlbums(self.args['id'])
      for k in albums.keys():
         self.wfile.write("""<a href="/album.rok?id=%s">%s</a><br>\n"""%(k,albums[k]))

   def cover(self):
      """display a cover of an album"""
      self.args = dict(cgi.parse_qsl(self.requete))
      self.send_response(200, 'OK')
      self.send_header('Content-type', 'image/png')
      self.end_headers()
      img = file(self.args['url'],"r")
      if img:
         self.wfile.write(img.read())
      img.close()


   def mp3(self):
      """stream a mp3 file"""
      self.args = dict(cgi.parse_qsl(self.requete))
      self.send_response(200, 'OK')
      self.send_header('Content-type', 'audio/mp3')
      self.end_headers()
      mp3 = file(self.args['url'],"r")
      if mp3:
         self.wfile.write(mp3.read())
      mp3.close()

   def listAlphabetise(self,data,existString,getString,getLetter):
      """Create a list alphabetized
      ie: with list of letters at the top and head letter at each new one
      data: ordered list of lines (each line is a list eg:(id,'name'))
      existString: callback: test existance of string to be displayed
      getString: callback: get a line, return string
      getLetter: callback: get a line, return 1st letter"""
      list=[]
      letter="#" # number and special characters
      header="""<div id="letters"><a href="1">%s</a> """%(letter)
      list.append("""<h3><a name="1">%s</a></h3>"""%(letter))
      for l in data:
         if existString(l):
            #print "%s,%s"%(l,getLetter(l))
            if (getLetter(l).lower() != letter and not getLetter(l).isdigit() and not getLetter(l) in self.listSpecChar):
               # new letter and not digit nor special char
               list.append("""<h3><a name="%s">%s</a></h3>"""%(getLetter(l).upper(),getLetter(l).upper()))
               header+="""<a href="#%s">%s</a> """%(getLetter(l).upper(),getLetter(l).upper())
               letter=getLetter(l).lower()
            list.append(getString(l))
      header+="</div><br/>"
      list.insert(0,header)
      return list
      
   def entete(self):
         """Display the head of the page"""
         self.wfile.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
         <html>
         <head>
            <title>wabaroK Collection</title>
            <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
            <link rel="stylesheet" type="text/css" href="themes/%s.css">
         </head>
         <body><div id='header'><h1>wabaroK</h1></div>"""%(conf['theme']))

   def stats(self):
      """display db statistics"""
      self.wfile.write("""<h2>Stats</h2>
      <ul class="menu_item">
         <li>Artists : %s</a></li>
         <li>Albums : %s</a></li>
         <li>Songs : %s</a></li>
      </ul>"""%(self.dico_stats['artists'],self.dico_stats['albums'],self.dico_stats['songs']))

   def menu(self):
      """Display the menu"""
      self.wfile.write("""<div id="nav"><h2>Menu</h2>
      <ul class="menu_item">
         <li><a href="/artists.rok">Artists</a></li>
         <li><a href="/albums.rok">Albums</a></li>
         <li><a href="/songs.rok">Songs</a></li>
      </ul>""")
      self.stats()
      self.wfile.write("""</div><div id="content">""")

   def piedepage(self):
      """Display the bottom of the page"""
      self.wfile.write("""</div><div id="footer">%s [<a href="http://kubuntu.free.fr/wabarok/">JJL</a>]</div></body></html>"""%(self.server_version))
   
   def listColumn(self,list,nbcol=2):
      """Display a list as nbcol column"""
      lcol = int(len(list)/nbcol) # col lenght
      self.wfile.write(list.pop(0)) # write list of letters
      self.wfile.write("<div id='content_col'>")
      c=0
      for l in list:
         if c >= lcol and l.find("<a name=")!=-1:
            # col length reached and head letter
            self.wfile.write("</div><div id='content_col'>")
            c=0
         self.wfile.write(l)
         c+=1
      self.wfile.write("</div>")
      
   def error(self,message):
      """Display an error message"""
      self.wfile.write("""<h3>%s</h3>"""%(message))


def exit(signum,frame):
   global event
   print "exiting (%d) ..."%(signum)
   sys.stdin.close()
   sys.exit(signum)

if __name__=='__main__':
   sys.stdout=file("wabaout.log","w",0)
   sys.stderr=sys.stdout

   conf.read()
   # get installed directory
   conf['dataPath'] = os.path.expanduser("~/.kde/share/apps/amarok/scripts/") + os.path.basename(sys.argv[0])[:-3]
   
   print conf
   
   signal.signal(signal.SIGTERM, exit)
   signal.signal(signal.SIGINT, exit)

   inputFromAmarok(sys.stdin,conf.guiKdialog).start()
   #conf.guiKdialog()
   
   httpd = HTTPServer(('',conf['port']), HTTPHandler)
   httpd.serve_forever()

